
$(document).ready(function () {

	var consoleText = "%cDecibelInsight: %cWebsiteId:%s %c%s",
		css1 = "color:#080;font-weight:bold;",
		css2 = 'color:#25649F;font-weight:bold;text-transform:none;',
		css3 = 'color:#800;font-weight:bold;text-transform:uppercase;';

//	(top === self) && console.log("%c%s","color:#25649F;font-weight:bold;",""
//	+"  _____               _  _            _   _____              _         _      _   \n"
//	+" |  __ \\             (_)| |          | | |_   _|            (_)       | |    | |  \n"
//	+" | |  | |  ___   ___  _ | |__    ___ | |   | |   _ __   ___  _   __ _ | |__  | |_ \n"
//	+" | |  | | / _ \\ / __|| || '_ \\  / _ \\| |   | |  | '_ \\ / __|| | / _` || '_ \\ | __|\n"
//	+" | |__| ||  __/| (__ | || |_) ||  __/| |  _| |_ | | | |\\__ \\| || (_| || | | || |_ \n"
//	+" |_____/  \\___| \\___||_||_.__/  \\___||_| |_____||_| |_||___/|_| \\__, ||_| |_| \\__|\n"
//	+"                                                                 __/ |            \n"
//	+"                                                                |___/             ");

	(top === self) && console.log('%cDECIBEL'+''+'%cINSIGHT', 'font-weight:900;color:#706f6f;font-size:40px;font-family:"Arial Black"', 'font-weight:900;font-style:italic;color:#b3b2b2;font-size:40px;font-family:"Arial Black"');

	chrome.storage.sync.get(['websiteId', 'url', 'server'], function(items) {

		if (!items || !items.url || !items.websiteId) {
			return;
		}
		var i,
			domains = items.url.split(','),
			pos,
			server = 'sr-tag.corp.cvscaremark.com';

		for (i=0; i<domains.length; ++i) {
			pos = location.href.indexOf(domains[i]);
			if (top===self && (pos===7 || pos===8)) {

				var code = "if(typeof _da_=='undefined'){(function(d,e,c,i,b,el,it) {"
						+"d._da_=d._da_||[];_da_.oldErr=d.onerror;_da_.err=[];"
						+"d.onerror=function(){_da_.err.push(arguments);_da_.oldErr&&_da_.oldErr.apply(d,Array.prototype.slice.call(arguments));};"
						+"d.DecibelInsight=b;d[b]=d[b]||function(){(d[b].q=d[b].q||[]).push(arguments);};"
						+"el=e.createElement(c),it=e.getElementsByTagName(c)[0];el.async=1;el.src=i;it.parentNode.insertBefore(el,it);"
						+"})(window,document,'script','https://"+server+"/i/"+items.websiteId+"/di.js','decibelInsight');}";

				var script = document.createElement('script');
				var headEl = document.querySelector('head');
				script.type = 'text/javascript';
				script.text = code;
				headEl.appendChild(script);

				break;
			}
		}
	});


	chrome.storage.sync.get(['attributionselector','autoattribution','attributioncolour','maskregex','automask'], function(items) {

		var autoattribution = items.autoattribution,
			selector = items.attributionselector,
			attributioncolour = items.attributioncolour,
			automask = items.automask,
			maskregex = items.maskregex;

		if (autoattribution) {
			drawAttributionMap(selector, attributioncolour);
		}

		if (automask) {
			maskDomContent(maskregex);
		}
	});


	chrome.runtime.onMessage.addListener( function(request) {
		// generateAttributionMap listener
		if (request.action === 'generateAttributionMap') {
			drawAttributionMap(request.selector, request.attributioncolour);
		}
		// generateAttributionMap listener
		if (request.action === 'maskDomContent') {
			maskDomContent(request.maskregex);
		}
		// dataCollection listener
		if (request.action === 'dataCollection') {
			showCollectedInfo(request);
		}
	});

	// display all collected information in the console
	function showCollectedInfo(request) {

		var postBody, postJson, params, type, match;

		if (top === self && top.location.href.indexOf('app.decibelinsight.com') === -1) {

			match = /\?type=([^&]+)/.exec(request.url);
			if (match) {
				type = match[1];
			}

			if (type) {
				postBody = request.postBody || '';
				if (postBody.substr(0,6) === 'DIB64;') {
					postBody = decodeURIComponent(escape(window.atob(postBody.substr(6))));
				}
				if (postBody.substr(0,1) === '{') {
					postBody = JSON.parse(postBody);
				}

				params = getParamObj(request.url.substr(request.url.indexOf('?')+1));

				switch(type) {
					case 'page':
						console.log(consoleText, css1, css2, params.wid, css3, type, $.extend({},params,getParamObj(postBody)));
						break;

					case 'html':
						console.log(consoleText, css1, css2, params.wid, css3, type, $.extend({},params,{html:postBody}));
						break;

					case 'resource':
						console.log(consoleText, css1, css2, params.wid, css3, type, $.extend({},params,{content:postBody}));
						break;

					case 'retention':
					case 'cookieflags':
						console.log(consoleText, css1, css2, params.wid, css3, type, params);
						break;

					case 'meta':
						console.log(consoleText, css1, css2, params.wid, css3, type, params, postBody);
						break;

					case 'multi':
						postJson = JSON.parse(postBody);
						if (Array.isArray(postJson)) {
							console.group(consoleText, css1, css2, params.wid, css3, 'multi', params);
							postJson.forEach(function(item) {
								if (item.data && item.data.content) {
									item.data.content = JSON.parse(item.data.content);
								}
								console.log("%c%s", css3, item.type, item.data);
							});
							console.groupEnd();
						}
						break;

				}
			}
		}
	}

	// mask dom content using regex
	function maskDomContent(maskregex) {

		var temp = maskregex.match(/^\/(.*?)\/([gim]*)$/);
		try	{
			if (temp) {
				maskregex = new RegExp(temp[1], temp[2]);
			} else {
				maskregex = new RegExp(maskregex, 'g');
			}
		} catch(i){
			maskregex = null;
		}

		if (maskregex) {
			maskTextNodesInDom(document.body, maskregex);
		}
	}

	// draw heatmap function
	function drawAttributionMap(selector, attributioncolour) {

		var i, minDiff, curValue, element,
			tempArray = {},
			hmDataNorm = [],
			//interactionColour = ["51,51,51", "51,51,204", "51,153,255", "51,204,204", "0,204,0", "255,255,0", "255,153,0", "255,0,0"],
			interactionColour = 'multi',
			min_val = 10000000000,
			max_val = 0,
			elementclicks = 0,
			shades = interactionColour.length,
			sel = 'a',
			docHeight,
			body = document.body,
			docEl = document.documentElement;

		if (selector !== undefined && selector !== '') {
			sel += ',' + selector;
		}

		if (attributioncolour !== '') {
			interactionColour = hexToRgb(attributioncolour);
		}

		$('#da_hm_cl_l, #da_hm_att_l, .da_hm_sr_d, .da_hm_sr_l, .da_hm_o, #di_object_table').remove();

		if($('.da_height_fix').length === 0){
			$('body').append('<div class="da_height_fix" style="clear: both; height: 0px;"></div>');
			docHeight = Math.max(body.scrollHeight, body.offsetHeight, docEl.clientHeight, docEl.scrollHeight, docEl.offsetHeight);
			$('body').css('min-height', docHeight+'px');
			$('html, body').show();
		}

		// prepare dom
		indexElements(sel);

		// draw heatmap
		addCSSRule();

		$('[data-di-id]').each(function(i, el){
			var id = el.getAttribute('data-di-id');
			if (isUndefined(tempArray[id])) {
				tempArray[id] = {
					id: id,
					el: el,
					c: Math.round(Math.random()*100)
				};
			}
		});

		for(i in tempArray){
			if (tempArray.hasOwnProperty(i)) {
				max_val = Math.max(max_val, tempArray[i].c);
				min_val = Math.min(min_val, tempArray[i].c);
				elementclicks += tempArray[i].c;
				hmDataNorm.push(tempArray[i]);
			}
		}
		hmDataNorm.sort(function(o1,o2){
			return o1.c - o2.c;
		});

		// min difference between blocks of coloured objects
		minDiff = max_val/shades;
		curValue = min_val;

		// add heatmap layers
		for (i = 0; i < hmDataNorm.length; i++) {
			element = hmDataNorm[i];

			if (element.c - curValue > minDiff) {
				curValue = element.c;
			}

			element.colour = getObjectColour(parseInt(curValue), max_val, min_val, interactionColour);
			addObjectHeatmap(element, elementclicks);
		}

		// set a timeout function on all hidden da heatmap element
		// to recalculate the heatmap layer once the element is visible
		clearTimeout(window.da_checkHiddenTimeout);
		window.da_checkHiddenTimeout = setTimeout(checkHiddenEl, 250);

		if (hmDataNorm.length) {
			hmDataNorm.sort(function(o1,o2){
				return o2.c - o1.c;
			});
			var di_object_table = $('<table></table>')
									.attr('id','di_object_table')
									.html("<thead><tr><th>Order</th><th>Element</th><th>Clicks</th></tr></thead><tbody></tbody>")
									.css('margin-top', (parseInt($('body').css('padding-bottom'))+20)+'px !important')
									.appendTo($('body')),
				di_object_tbody = di_object_table.find('tbody');

			for (i = 0; i < hmDataNorm.length; i++) {
				$('[data-da-hm-o="'+hmDataNorm[i].id+'"]').addClass('da_hm_number').find('.da_hm_o_b > span').html(i+1);
				di_object_tbody.append('<tr><td>'+(i+1)+'</td><td>'+hmDataNorm[i].id+'</td>'+$('[data-da-hm-o="'+hmDataNorm[i].id+'"]').data('tableinfo')+'</tr>');
			}
		}
	}

	// heatmap mouse bindings
	$('body').on('mouseover mouseout', '.da_hm_o .da_hm_o_b, .da_i_m', heatmapLayerMouseOverOut);
	$('body').on('click', '.da_hm_o .da_hm_o_b, .da_i_m', function() {
		return false;
	});




	// functions

	function validateId(id) {
		return /^[A-Za-z][A-Za-z0-9_\-\:\.]*$/.test(id);
	}

	function isEmpty(value) {
		return (typeof value === 'undefined' || value === null || value === "");
	}

	function isUndefined(value) {
		return typeof value === 'undefined';
	}

	function isNumber(n) {
		return (n > 0 || n < 0 || n == 0);
	}

	function getParamObj(params) {
		var o = {};
		if (params === "") { return o; }
		params = params.split('&');

		for (var i = 0; i < params.length; ++i) {
			var p = params[i].split('=');
			if (p.length === 2) {
				o[p[0]] = decodeURIComponent(p[1]);
			}
		}
		return o;
	}

	function inArray(item, array, i) {
		var len;
		if (array) {
			len = array.length;
			i = i ? i < 0 ? Math.max(0, len + i) : i : 0;
			for (; i < len; i++) {
				// Skip accessing in sparse arrays
				if (i in array && array[i] === item) {
					return i;
				}
			}
		}
		return -1;
	}

	function indexElements(sel) {
		$(sel).not('[data-di-id]').each(function(i, el){
			if (((el.id && validateId(el.id)) || !isEmpty(el.href)) && !insideDiId(el)) {
				var id = getDiId(el);
				if (id.indexOf(' ') > -1) {
					id = 'di-id-'+hash(id);
				}
				el.setAttribute('data-di-id', id);
			}
		});
	}

	function isValidRgb(rgb) {

		var i, n, temp = rgb.split(',');

		for(i=0; i<temp.length; i++) {

			n = temp[i].trim();

			if (!isNumber(n) || (n > 255 || n < 0)) {
				return false;
			}
		}
		return true;
	}

	function hexToRgb(hex) {

		if (isValidRgb(hex)) {
			return hex;
		}

		hex = hex.replace('#','');
		var bigint = parseInt(hex, 16);
		var r = (bigint >> 16) & 255,
			g = (bigint >> 8) & 255,
			b = bigint & 255;

		return r + "," + g + "," + b;
	}

	function getDiId(el) {

		var id = '';

		if (el.id && validateId(el.id)) {
			id = '#'+el.id;
		} else {
			if (!(/body/i.test(el.tagName)) && !(/html/i.test(el.tagName))) {
				id = getDiId(el.parentNode)
						+ " > "
						+ el.tagName.toLowerCase()
						+ (isEmpty(el.href) ? '' : '[href="'+el.href+'"]');
			} else {
				id = el.tagName.toLowerCase();
			}
		}

		return id;
	}

	function insideDiId(el) {
		var result = false;
		while (!result && !isEmpty(el) && el !== document.body) {
			result = el.hasAttribute('data-di-id');
			el = el.parentNode;
		}
		return result;
	}

	function makeCRCTable(){
		var c, n, k, crcTable = [];
		for (n =0; n < 256; n++) {
			c = n;
			for (k =0; k < 8; k++) {
				c = ((c&1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
			}
			crcTable[n] = c;
		}
		return crcTable;
	}

	function crc32(str) {
		var crcTable = window._da_crcTable || (window._da_crcTable = makeCRCTable()),
			crc = 0 ^ (-1), i;
		for (i = 0; i < str.length; i++) {
			crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 0xFF];
		}
		return (crc ^ (-1)) >>> 0;
	}

	function hash(str) {
		str = ''+(isEmpty(str) ? '' : str);
		return crc32(str.substr(0,str.length/2)).toString(16) +'-'+ crc32(str.substr(str.length/2)).toString(16);
	}

	function getLayerColor(color_scale) {

		var r1, g1, b1, r2, g2, b2, r, g, b;

		if (color_scale < 25) {
			color_scale = color_scale * 4;
			r1 = 0;
			g1 = 0;
			b1 = 255;
			r2 = 0;
			g2 = 255;
			b2 = 255;
		} else if (color_scale < 50) {
			color_scale = (color_scale - 25) * 4;
			r1 = 0;
			g1 = 255;
			b1 = 255;
			r2 = 0;
			g2 = 255;
			b2 = 0;
		} else if (color_scale < 75) {
			color_scale = (color_scale - 50) * 4;
			r1 = 0;
			g1 = 255;
			b1 = 0;
			r2 = 255;
			g2 = 255;
			b2 = 0;
		} else {
			color_scale = (color_scale - 75) * 4;
			r1 = 255;
			g1 = 255;
			b1 = 0;
			r2 = 255;
			g2 = 0;
			b2 = 0;
		}

		r = Math.round((r1 * (100 - color_scale) / 100) + (r2 * (color_scale) / 100));
		g = Math.round((g1 * (100 - color_scale) / 100) + (g2 * (color_scale) / 100));
		b = Math.round((b1 * (100 - color_scale) / 100) + (b2 * (color_scale) / 100));

		return r + "," + g + "," + b;
	}

	function getObjectColour(value, max, min, interactionColour) {

		//value = ( (old_value - old_min) / (old_max - old_min) ) * (new_max - new_min) + new_min
		var scale, tempColour, colour = {main:'',button:''};

		if (interactionColour === 'multi') {

			scale = 100;
			if(max !== min){
				scale = (value - min) / (max - min) * 100;
			}
			tempColour = getLayerColor(scale);

			colour.main = 'rgba('+tempColour+',0.75)';
			colour.button = 'rgba('+tempColour+',1)';

		} else {
			if (max - min === 0) {
				scale = 80;
			} else {
				scale = ((value - min) / (max - min)) * (80 - 20) + 20;
			}
			scale = (scale/100).toFixed(2);

			colour.main = 'rgba('+interactionColour+','+scale+')';
			colour.button = 'rgba('+interactionColour+','+(1*scale+0.2)+')';
		}

		return colour;
	}

	function checkHiddenEl() {
		var da_hidden_elements = $('.da_hidden_analytic_element');
		da_hidden_elements.each(function(){
			var $el = $(this);
			if ($el.is(':visible')) {
				$el.removeClass('da_hidden_analytic_element');

				$el.find('.da_hm_o').each(function(){
					if (!$(this).hasClass('da_hm_o_inline')) {
						$(this).css({
							width	: getWidthHeight($el).width + 'px',
							height	: getWidthHeight($el).height + 'px'
						});
					}
					$(this).show();
				});
			};
		});
		if (da_hidden_elements.length) {
			clearTimeout(window.da_checkHiddenTimeout);
			setTimeout(checkHiddenEl, 250);
		}
	}

	function addObjectHeatmap(element, totalClicks) {

		var templayer, info, tableinfo,
			mapId, mapName, coords, shape, $temp,
			$el, tempelements = $('[data-di-id="'+element.id+'"]');

		$('[data-da-hm-o="'+element.id+'"]').remove();

		tempelements.each(function() {
			$el = $(this);

			if ($el.is('area')) {
				mapId = $el.parents('map').attr('id');
				mapName = $el.parents('map').attr('name');
				$temp =  $('[usemap="#'+mapId+'"], [usemap="#'+mapName+'"]');
				if ($temp.length) {
					coords = $el.attr('coords');
					shape = $el.attr('shape');
					$el = $temp;
				}
			}

			// set element position to relative if needed
			if (ifSetRelative($el)) {
				$el.addClass('di-relative');
			}

			// object heatmap container
			templayer = $('<div></div>')
				.attr('data-da-hm-o', element.id)
				.addClass('da_hm_o');

			if ($el.is('img, button, input, select')) {
				templayer.css('cssText', getImageHmCss($el, coords, shape));
				$el.after(templayer);

			} else if (isInline($el)) {
				templayer.addClass('da_hm_o_inline');
				$el
					.addClass('di-inline')
					.attr('data-di-back', $el[0].style.backgroundColor)
					.css('background-color', element.colour.main)
					.append(templayer);
			} else {
				templayer.css({
					width	: getWidthHeight($el).width + 'px',
					height	: getWidthHeight($el).height + 'px'
				});
				$el.append(templayer);
			}

			// color layer
			$('<div></div>')
				.addClass('da_hm_o_i')
				.css({
					'background': 'none '+element.colour.main,
					'box-shadow': '0 0 5px 0 '+element.colour.main
				}).appendTo(templayer);

			// info
			info = '<div class="da_i_mi">Clicks: <strong>' + element.c + '</strong> (' + Math.round(element.c / totalClicks * 100 * 100) / 100 + '% of ' + totalClicks + ' clicks)</div>';
			tableinfo = '<td>' + element.c + ' (' + Math.round(element.c / totalClicks * 100 * 100) / 100 + '% of ' + totalClicks + ' clicks)</td>';
			templayer.data('tableinfo', tableinfo);

			// info button
			$('<div><span style="background-color:'+element.colour.button+';background:'+element.colour.button+';"></span></div>')
				.addClass('da_hm_o_b')
				.attr('data-info', info)
				.appendTo(templayer);

			if ($el.is(':hidden')) {
				$el.addClass('da_hidden_analytic_element');
				templayer.hide();
			}
		});
	}

	function getImageHmCss($el, coords, shape) {

		var css = '',
			wh = getWidthHeight($el),
			pos = $el.position(),
			w = 0, h = 0, t = 0, l = 0, temp, i;

		if (coords) {
			temp = coords.split(',');
			if (shape === 'rect' && temp.length === 4) {
				l = parseInt(temp[0].trim());
				t =  parseInt(temp[1].trim());
				w = parseInt(temp[2].trim()) - parseInt(temp[0].trim());
				h = parseInt(temp[3].trim()) - parseInt(temp[1].trim());

			} else if (shape === 'circle' && temp.length === 3) {
				l = parseInt(temp[0].trim()) - parseInt(temp[2].trim());
				t = parseInt(temp[1].trim()) - parseInt(temp[2].trim());
				w = parseInt(temp[2].trim()) * 2;
				h = parseInt(temp[2].trim()) * 2;

			} else if (shape === 'poly' && temp.length % 2 === 0) {
				w = null, h = null, t = null, l = null;
				for (i = 0; i<temp.length; i = i+2) {
					l = Math.min(l===null?temp[i]:l, temp[i]);
					t = Math.min(t===null?temp[i+1]:t, temp[i+1]);
					w = Math.max(w===null?temp[i]:w, temp[i]);
					h = Math.max(h===null?temp[i+1]:h, temp[i+1]);
				}
				w = w - l;
				h = h - t;
			}
		}

		css += 'width:' + (w || wh.width) + 'px;';
		css += 'height:' + (h || wh.height) + 'px;';
		css += 'top:' + (pos.top + parseInt($el.css('margin-top')) + t) + "px !important;";
		css += 'left:' + (pos.left + parseInt($el.css('margin-left')) + l) + "px !important;";

		return css;
	}

	function getWidthHeight($el) {

		var wh = {
			width: 0,
			height: 0
		};

		wh.width = $el.outerWidth();
		wh.height = $el.outerHeight();

		if (!(wh.width > 0 && wh.height > 0)) {
			var rect, left, right, top, bottom;
			$el.children().each(function() {
				rect = this.getBoundingClientRect();
				if (rect.width) {
					left = isEmpty(left) ? rect.left : Math.min(left, rect.left);
					right = isEmpty(right) ? rect.right : Math.max(right, rect.right);
				}
				if (rect.height) {
					top = isEmpty(top) ? rect.top : Math.min(top, rect.top);
					bottom = isEmpty(bottom) ? rect.bottom : Math.max(bottom, rect.bottom);
				}

			});
			wh.width = right - left;
			wh.height = bottom - top;
		}

		return wh;
	}

	function getElBoundTop(el) {
		return el.getBoundingClientRect().top;
	}

	function isInline($el) {

		var display = $el.css('display'),
			inline = display === 'inline';

		$el.find('*').each(function() {
			if ($(this).css('display') !== 'inline' || $(this).is('img, button, input, select')) {
				inline = false;
				return false;
			}
		});

		if (!inline && display === 'inline') {
			$el.css('display', 'inline-block');
		}

		return inline;
	}

	/**
	 * Returns if element should be set relative
	 *
	 * @param {jQuery Element} $el
	 * @returns {boolean}
	 */
	function ifSetRelative($el) {

		var rel = true, $temp, $offsetParent;

		if ($el.css('position') === 'static') {
			$el.find('*').each(function() {
				$temp = $(this);
				if ($temp.css('position') === 'absolute') {
					$offsetParent = $temp.offsetParent();
					if ($offsetParent.length && !$.contains($el[0], $offsetParent[0])) {
						rel = false;
						return false;
					}
				}
			});

		} else {
			rel = false;
		}

		return rel;
	}

	function heatmapLayerMouseOverOut(e) {
		var $el = $(this);

		function getPositionCss() {

			var css = {},
				$window = $(window),
				docViewRight = $window.scrollLeft() + $window.width(),
				docViewBottom = $window.scrollTop() + $window.height(),
				buttonLeft = $el.offset().left,
				buttonTop = $el.offset().top,
				buttonWH = 16,
				divHeight = 115,
				divWidth = 249;

			if (buttonLeft >= (divWidth-buttonWH)) {
				css.left = (buttonLeft-divWidth+buttonWH) + 'px';
			} else if ((buttonLeft+divWidth) > docViewRight) {
				css.left = (docViewRight-divWidth) + 'px';
			} else {
				css.left = buttonLeft + 'px';
			}

			if ((docViewBottom - (buttonTop+buttonWH)) > divHeight) {
				css.top = (buttonTop+buttonWH) + 'px';
			} else {
				css.top = (buttonTop-divHeight) + 'px';
			}

			return css;
		}

		if (e.type === 'mouseover') {
			if ($el.is('.da_hm_o_b') && $('.da_i_m').length === 0) {
				$('<div></div>')
						.addClass('da_i_m')
						.html($el.data('info'))
						.css(getPositionCss())
						.appendTo($('body'));
			}

		} else {
			var relTarg = $(e.relatedTarget || e.toElement);
			if (!relTarg.is('.da_hm_o_b, .da_i_m') && relTarg.parents('.da_hm_o_b, .da_i_m').length === 0) {
				$('.da_i_m').remove();
			}
		}

		return false;
	}

	function addCSSRule() {

		if ($("head #di_hm_css1").length === 0) {

			var style, cssArray = [];
			cssArray.push("#da_hm_att_l{top:0;position:absolute;z-index:2147483640;pointer-events:none;display:none;}");
			cssArray.push("#da_hm_att_li{position:absolute;top:0;}");
			cssArray.push("#da_hm_cl_c{opacity:0.75;}");
			cssArray.push("#da_hm_cl_l{top:0;position:absolute;z-index:2147483640;pointer-events:none;display:none;background-color:rgba(0,0,0,0.2);}");
			cssArray.push(".da_hm_sr_l{left:0;position:absolute;width:100%;z-index:2147483640;opacity:0.25;pointer-events:none;}");
			cssArray.push(".da_hm_sr_d{left:0;position:absolute;width:100%;height:3px;z-index:2147483641;pointer-events:none;}");
			cssArray.push(".da_hm_sr_d.fold{height:0px;border-top:3px dashed #ff33ee;z-index:2147483642;}");
			cssArray.push(".da_hm_sr_d > div{bottom:3px;font-size:20px;font-weight:bold;position:absolute;right:3px;background-color:#fff;opacity:0.6;padding:0 5px;color:#000;font-family:Verdana,Geneva,sans-serif;}");
			cssArray.push(".da_hm_sr_d.fold > div{left:3px;right:auto;}");

			cssArray.push(".da_hm_o{box-sizing:content-box !important;top:0 !important;left:0 !important;padding:0 !important;position:absolute !important;pointer-events:none;float:none !important;display:block !important;}");
			cssArray.push(".da_hm_o_i{box-sizing:content-box !important;float:none !important;padding:0 !important;top:auto;width:100% !important;height:100% !important;display:block !important;border-radius:2px !important;}");
			cssArray.push(".da_hm_o_b{box-sizing:content-box !important;padding:0 !important;margin:0 !important;width:auto !important;height:auto !important;top:0 !important;right:0 !important;position:absolute !important;cursor:pointer !important;pointer-events:auto !important;background-color:#FFFFFF !important;border-bottom:1px solid #fff !important;border-left:1px solid #fff !important;display:block !important;}");
			cssArray.push(".da_hm_o_b > span{box-sizing:content-box !important;display:block !important;margin:0 !important;color:#fff !important;padding:0 3px !important;width:auto !important;height:auto !important;font-size:14px !important;line-height:16px !important;font-family:Verdana,Geneva,sans-serif;position:initial !important;font-weight:initial !important;min-height:initial !important;}");cssArray.push(".da_hm_o_inline{box-sizing:content-box !important;width:0px !important;height:0px !important;display:inline-block !important;left:auto !important;top:auto !Important;}");

			cssArray.push(".da_i_m{box-sizing:content-box !important;width:225px;min-height:50px;border:none !important;background:none #333333 !important;padding:8px 12px !important;position:absolute !important;top:0;left:0;z-index:2147483643;color:#FFFFFF !important;cursor:default !important;font-family:Arial,Helvetica,sans-serif !important;font-weight:normal;text-transform:none;font-size:14px !important;opacity:0.95 !important;}");
			cssArray.push(".da_i_mi{box-sizing:content-box !important;border-top: 1px solid #666666 !important;text-align:left !important;color:#FFFFFF !important;cursor:default !important;background:none #333333 !important;display:block;z-index:2147483643;left:0;top:0;padding:5px 0 !important;position:relative;}");
			cssArray.push(".da_i_mi strong{color:#FFFFFF !important;}");
			cssArray.push(".da_i_mi:first-child,.da_i_mi:last-child{box-sizing:content-box !important;border-top: none !important;}");
			cssArray.push(".da_i_mi:last-child{box-sizing:content-box !important;padding:0 !important;}");
			cssArray.push(".da_i_m button{box-sizing:content-box !important;cursor:pointer !important;float:right !important;background-color:#FFF !important;color:#000 !important;border:1px solid #666 !important;padding:1px 3px !important;}");

			cssArray.push("table#di_object_table,#di_object_table thead,#di_object_table tbody,#di_object_table tfoot,#di_object_table tr,#di_object_table th,#di_object_table td {color:#000 !important;background-color:#fff !important;background:#fff !important;width:auto;height:auto;margin:0;padding:0;border:none;border-collapse:collapse;border-spacing:0;vertical-align:middle;text-align:left;font-family:Arial,Helvetica,sans-serif;font-weight:normal;font-size:14px;-webkit-border-horizontal-spacing:0;-webkit-border-vertical-spacing:0;}");
			cssArray.push("table#di_object_table{width:98% !important;margin:20px auto 10px !important;}");
			cssArray.push("table#di_object_table th,table#di_object_table td{border:1px solid #333!important;padding:5px!important;}");
			cssArray.push("table#di_object_table th{font-weight: bolder!important;}");
			cssArray.push(".di-relative{position:relative !important;}");

			style = '<style id="di_hm_css1" type="text/css">' + cssArray.join("\n") + "</style>";
			$("head").append(style);
		}
	}

	function maskText(str) {
		return str.replace(/[^\s@]/g, '*');
	}

	function maskTextNodesInDom(elem, maskregex) {
		if (elem) {
			for (var nodes = elem.childNodes, i = nodes.length; i--; ) {
				var node = nodes[i], nodeType = node.nodeType;
				if (nodeType === 3) {
					if (maskregex.test(node.nodeValue)) {
						node.nodeValue = node.nodeValue.replace(maskregex, maskText);
					}
				}
				else if (nodeType === 1 || nodeType === 9 || nodeType === 11) {
					maskTextNodesInDom(node, maskregex);
				}
			}
		}
	}

});
